LeetCode 363 Max Sum of Rectangle No Larger Than K (二分)

来源:互联网 发布:咋么样开淘宝店 编辑:程序博客网 时间:2024/05/16 18:36

Given a non-empty 2D matrix matrix and an integerk, find the max sum of a rectangle in the matrix such that its sum is no larger thank.

Example:

Given matrix = [  [1,  0, 1],  [0, -2, 3]]k = 2

The answer is 2. Because the sum of rectangle[[0, 1], [-2, 3]] is 2 and 2 is the max number no larger than k (k = 2).

Note:

  1. The rectangle inside the matrix must have an area > 0.
  2. What if the number of rows is much larger than the number of columns?


题目链接:https://leetcode.com/problems/max-sum-of-sub-matrix-no-larger-than-k

题目分析:暴力的做法是row^2 * col^2的,Note里面提到row远大于col,则可以考虑尽量少的去循环row,可以枚举任意两列,然后枚举行,枚举行的时候可以直接累加之前行的值,找不大于k的最大的,显然这里可以用二分优化复杂度,将所有子矩阵的值丢到set里,因此查找的复杂度变为log(row),所以总的复杂度为col^2 * row * log(row)

class Solution {public:    int maxSumSubmatrix(vector<vector<int>>& matrix, int k) {        int n = matrix.size();        if (n == 0) {            return 0;        }        int m = matrix[0].size();        int ans = INT_MIN;        set<int> st;        set<int> :: iterator it;        for (int i = 0; i < m; i ++) {            vector<int> sum(n, 0);            for (int j = i; j < m; j ++) {                int curSum = 0, curMax = INT_MIN;                st.clear();                st.insert(0);                for (int row = 0; row < n; row ++) {                    sum[row] += matrix[row][j];                       curSum += sum[row];                    it = st.lower_bound(curSum - k);                    if (it != st.end()) {                        curMax = max(curMax, curSum - *it);                    }                    st.insert(curSum);                }                ans = max(ans, curMax);            }        }        return ans;    }};


0 0
原创粉丝点击